/* =========================================================================

NAME: UltraBorder

AUTHOR: Oleg Butrin (obutrin@indesign.rudtp.ru)
Some functions and interface elemets created by Vitaly Batushev (vbatushev@indesign.rudtp.ru)
HOMEPAGE: http://indesign.rudtp.ru
DATE  : 20.11.2003



COMMENT:
Script make border around paragraph with custom paragraph style applied

RIGHT:
You have the right to use and distribute this script.
You have the right to modify this script for own needs. 
It is desirable to send the variant to the author of a script.
You have no right to distribute the modified script from author's name.
You have no right to have profit from sale of a script.

The author of a script does not sustain the responsibility in all cases of loss data and other kinds of losses if they have arisen in the time of using a script.
You use this script at your own fear and risk.

============================================================================ */
var versionUB = "1.5";

with (app) {
//Check documents open and text Object selected
	if (documents.length<1) {
		alert("No documents open!\nOpen document, select text object and try again.");
		exit();
	}
	if (selection.length!=1) {
		alert("No objects selected or many objects selected!\nOpen document, select text object and try again.");
		exit();
	}
	if ((selection[0].constructor.name!="TextFrame")&&(selection[0].constructor.name!="Text")&&(selection[0].constructor.name!="InsertionPoint")) {
		alert("Selected object isn't text object!\nOpen document, select text object and try again.");
		exit();
	}
//Set up variables before make UI
	var myDoc = activeDocument;
	var mySelection = myDoc.selection[0];
	var myStory = myDoc.selection[0].parentStory;
	//var myStory = mySelection;
	var myParagraphs = myStory.paragraphs;
	var myParaStyles = myDoc.paragraphStyles;
	var myStrokeStyles = myDoc.strokeStyles;
	var mySwatches = myDoc.swatches;
//Create arrays for variable data
	var mySolidId = 0;
	var myParaStylesList = new Array();
	var myStrokeStylesList = new Array();
	var mySwatchesList = new Array();
	var mySizeList = new Array("0","0.1","0.25","0.5","0.75","1","2","3","4","5","6","7","8","9","10");
	var myPercentList = new Array("5","10","15","20","25","30","35","40","45","50","55","60","65","70","75","80","85","90","95","100");
//Fill arrays	
	for (var myCounter = 0; myCounter < myParaStyles.length; myCounter++) {
		myParaStylesList[myCounter] = myParaStyles[myCounter].name
	}
	for (var myCounter = 0; myCounter < myStrokeStyles.length; myCounter++) {
		myStrokeStylesList[myCounter] = myStrokeStyles[myCounter].name
		if (myStrokeStyles[myCounter].name == "Solid") {
			mySolidId = myCounter;
		}
	}
	for (var myCounter = 0; myCounter < mySwatches.length; myCounter++) {
		mySwatchesList[myCounter] = mySwatches[myCounter].name
	}
//Create UI (very hard job 8-[ )
	var myDialog = dialogs.add({name:"Ultra Border Maker " + versionUB});
	with (myDialog.dialogColumns.add()){
		with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Paragraph style:"});
			var mySelectedParaStyle = dropdowns.add({selectedIndex:0, stringList:myParaStylesList});
		}
		with (borderPanels.add().dialogColumns.add()) {
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Style:", minWidth:35});
				var mySelectedStrokeStyle = dropdowns.add({selectedIndex:mySolidId, stringList:myStrokeStylesList, minWidth:197});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Color:", minWidth:35});
				var mySelectedSwatch = dropdowns.add({selectedIndex:2, stringList:mySwatchesList, minWidth:197});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Tint:", minWidth:35});
				var mySelectedTint = percentComboboxes.add({editValue:100, stringList:myPercentList, smallNudge:5, largeNudge:10, maximumValue:100});
				staticTexts.add({staticLabel:"Stroke:", minWidth:47});
				var mySelectedStroke = measurementComboboxes.add({editValue:1, stringList:mySizeList, smallNudge:0.25, largeNudge:1, maximumValue:100});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Fill color:", minWidth:35, minWidth:50});
				var mySelectedFillColor = dropdowns.add({selectedIndex:0, stringList:mySwatchesList});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Fill tint:", minWidth:35, minWidth:50});
				var mySelectedFillTint = percentComboboxes.add({editValue:100, stringList:myPercentList, smallNudge:5, largeNudge:10, maximumValue:100});
			}
			with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Space around:", minWidth:80});
					var mySelectedSpaceAround = realEditboxes.add({editValue:1, smallNudge:0.25, largeNudge:1, maximumValue:100, minWidth:40});
					staticTexts.add({staticLabel:"mm"});
			}
			with (dialogRows.add()) {
					staticTexts.add({staticLabel:"Space in:", minWidth:80});
					var mySelectedSpaceIn = realEditboxes.add({editValue:1, smallNudge:0.25, largeNudge:1, maximumValue:100, minWidth:40});
					staticTexts.add({staticLabel:"mm"});
			}
		}
	}
//Show dialog
	var myResult = myDialog.show();
	if (myResult == false) {
		exit();
	}
//Find paragraphs with user custom style
	for (var myCounter = 0; myCounter < myParagraphs.length; myCounter++) {
		if (myParagraphs[myCounter].appliedParagraphStyle.name == myParaStylesList[mySelectedParaStyle.selectedIndex]) {
//Set find paragraphs as current
			var myCurrentParagraph = myParagraphs[myCounter];
//if tables in paragraph more at once, ignore this paragraph
			if (myCurrentParagraph.tables.length > 1) {
				continue;
			}
			if (myCurrentParagraph.tables.length == 1) {
// If paragraph previous to converted to table
				var myTable = myCurrentParagraph.tables[0];
				with (myTable) {
					width += topBorderStrokeWeight;	
				}
			} else {
				var myStartSelection = myCurrentParagraph.characters[0].index;
				var myEndSelection = myCurrentParagraph.characters[myCurrentParagraph.characters.length-2].index;
//Set interval of the text to convert to tables
				var mySelectedText = myStory.characters.itemByRange(myStartSelection, myEndSelection);
//No need to select text! Just use method! Greate!!!
				mySelectedText.convertToTable();
				var myTable = myCurrentParagraph.tables[0];				
			}
			with (myTable) {

//Apply setting to table				
				width -= mySelectedStroke.editValue * 0.353;
				topBorderStrokeColor = mySwatches[mySelectedSwatch.selectedIndex];
				bottomBorderStrokeColor = mySwatches[mySelectedSwatch.selectedIndex];
				leftBorderStrokeColor = mySwatches[mySelectedSwatch.selectedIndex];
				rightBorderStrokeColor = mySwatches[mySelectedSwatch.selectedIndex];

				topBorderStrokeTint = mySelectedTint.editValue;
				bottomBorderStrokeTint = mySelectedTint.editValue;
				leftBorderStrokeTint = mySelectedTint.editValue;
				rightBorderStrokeTint = mySelectedTint.editValue;

				topBorderStrokeType = myStrokeStyles[mySelectedStrokeStyle.selectedIndex];
				bottomBorderStrokeType = myStrokeStyles[mySelectedStrokeStyle.selectedIndex];
				leftBorderStrokeType = myStrokeStyles[mySelectedStrokeStyle.selectedIndex];
				rightBorderStrokeType = myStrokeStyles[mySelectedStrokeStyle.selectedIndex];

				topBorderStrokeWeight = mySelectedStroke.editValue + " pt";
				bottomBorderStrokeWeight = mySelectedStroke.editValue + " pt";
				leftBorderStrokeWeight = mySelectedStroke.editValue + " pt";
				rightBorderStrokeWeight = mySelectedStroke.editValue + " pt";
								
				spaceBefore = mySelectedSpaceAround.editValue + " mm";
				spaceAfter = mySelectedSpaceAround.editValue + " mm";

//Apply setting to cell	
				with (myTable.cells[0]){
					fillColor = mySwatches[mySelectedFillColor.selectedIndex];
					fillTint = mySelectedFillTint.editValue;
					
					topInset = mySelectedSpaceIn.editValue + " mm";
					bottomInset = mySelectedSpaceIn.editValue + " mm";
					leftInset = mySelectedSpaceIn.editValue + " mm";
					rightInset = mySelectedSpaceIn.editValue + " mm";
				} 
			}
		}
	}
//Select object and exit
	myDoc.select (mySelection);
	myDialog.destroy();
	exit();
}